#include <stdio.h>

#define N 10


__global__ void add (int *a, int *b, int *c) {
	int tid=blockIdx.x;

	if (tid<N) {
		c[tid]=a[tid]+b[tid];
	}
}


int main(int arc, char **argv) {

	int a[N],b[N],c[N];
	int *dev_a,*dev_b,*dev_c;
	int i;

	/* Allocate memory on GPU */
	cudaMalloc((void **)&dev_a,N*sizeof(int));
	cudaMalloc((void **)&dev_b,N*sizeof(int));
	cudaMalloc((void **)&dev_c,N*sizeof(int));

	/* Fill the host arrays with values */
	for(i=0;i<N;i++) {
		a[i]=-i;
		b[i]=i*i;
	}

	cudaMemcpy(dev_a,a,N*sizeof(int),cudaMemcpyHostToDevice);
	cudaMemcpy(dev_b,b,N*sizeof(int),cudaMemcpyHostToDevice);

	add<<<N,1>>>(dev_a,dev_b,dev_c);

	cudaMemcpy(c,dev_c,N*sizeof(int),cudaMemcpyDeviceToHost);

	/* results */
	for(i=0;i<N;i++) {
		printf("%d+%d=%d\n",a[i],b[i],c[i]);
	}

	cudaFree(dev_a);
	cudaFree(dev_b);
	cudaFree(dev_c);

	return 0;
}

